﻿Type=Class
Version=2.7
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private Anim As AnimationPlus 
	
	Dim pnlHolder As Panel 
	Dim pnls() As Panel 
	Dim pnlFocus As Panel 
	Dim pnlFocus2 As Panel 
	
	Public indicatorSize As Int = 20dip
	Public focusSize As Int = 30dip
	Private x As Double = (focusSize-indicatorSize)/2

	Private newX As Int 
	
	Private pModule As Object 
End Sub

'Initializes the PageIndicator. This object is used inside the StartWizard
Public Sub Initialize(parentmodule As Object, numPages As Int)
	pnlHolder.Initialize("")
	pnlHolder.Color = Colors.Transparent 
	Dim pnls(numPages) As Panel 
	For i = 0 To numPages-1 
		pnls(i).Initialize("pnlIndicator")
		pnls(i).Tag = i
	Next
	pnlFocus.Initialize("")
	pModule = parentmodule
End Sub

'Adds the PageIndicator to a parent view
Public Sub AddToParent(parent As Panel,l As Int, t As Int, w As Int, h As Int)
	parent.AddView(pnlHolder, l,t,w,h)
	CreatePager
End Sub

'Set the Indicator Size and the focussed indicator size
Public Sub SetIndicatorSize(indicator_size As Int, focus_size As Int)
	indicatorSize = indicator_size
	focusSize = focus_size 
	x = (focusSize-indicatorSize)/2
End Sub

Private Sub CreatePager
	Dim numPages = pnls.Length 
	Dim indicatorSep As Int = (pnlHolder.Width - (numPages * indicatorSize)) / numPages
	Log(numPages)
	For i = 0 To numPages-1
		pnlHolder.AddView(pnls(i), (i*(indicatorSep+indicatorSize))+(indicatorSep)/2 , (pnlHolder.Height -indicatorSize)/2, indicatorSize, indicatorSize)
		pnls(i).Color = Colors.RGB(100,200,220)
	Next

	pnlHolder.AddView(pnlFocus, (pnls(0).Left-x), pnls(0).Top-x, focusSize,focusSize)
	pnlFocus.Color = Colors.rgb(185,100,80) 
	pnlFocus.SendToBack 
End Sub

'Change Focus of the Page Indicator (animates with Swipey movement)
Public Sub SetFocus(page As Int)
	If page > pnls.Length-1 Then Return
	
	Dim dx, dy As Double 
	dx = pnls(page).Left - x
	'dy = pnls(page).Top - x
	'animate from current page to new page
	Dim cx, cy As Double 
	cx = pnlFocus.Left + (pnlFocus.Width/2)
	cy = pnlFocus.Top + (pnlFocus.Height/2)
	dx = dx + (pnlFocus.Width/2)
	newX = dx - cx
	Anim.InitializeTranslate("Anim",0,0, dx - cx,0 )
	'Anim.PersistAfter = True
	Anim.Duration = 400
	Anim.SetInterpolator(Bit.OR(Anim.INTERPOLATOR_OVERSHOOT,Anim.INTERPOLATOR_DECELERATE)   )
	Anim.Start(pnlFocus)
End Sub

Private Sub Anim_AnimationEnd
	pnlFocus.Left = pnlFocus.Left + newX
End Sub

'Change Focus of the Page Indicator
'AnimType can be "Scale" or "Alpha"
Public Sub SetFocus2(page As Int,AnimType As String )
If page > pnls.Length-1 Then Return
	
	Dim dx, dy As Double 
	dx = pnls(page).Left - x
	'dy = pnls(page).Top - x
	'animate from current page to new page
	Dim cx, cy As Double 
	cx = pnlFocus.Left + (pnlFocus.Width/2)
	cy = pnlFocus.Top + (pnlFocus.Height/2)
	dx = dx + (pnlFocus.Width/2)
	newX = dx - cx
	
	Dim Anim2 As AnimationPlus 
	Dim pnlFocus2 As Panel 
	pnlFocus2.Initialize("")

	Dim newPage As Int  = page
	If newPage = pnls.Length Then newPage = 0

	pnlHolder.AddView(pnlFocus2, (pnls(newPage).Left-x), pnls(newPage).Top-x, focusSize,focusSize)
	pnlFocus2.Color = Colors.rgb(185,100,80) 
	pnlFocus2.SendToBack 

	If AnimType = "Alpha" Then
		Anim.InitializeAlpha("AnimAlpha1",1,0)
		Anim2.InitializeAlpha("AnimAlpha2",0,1)
	Else
		Anim.InitializeScaleCenter("AnimAlpha1",1,1,0.5,0.5,pnlFocus)
		Anim2.InitializeScaleCenter("AnimAlpha2",0.5,0.5,1,1,pnlFocus2)
	End If
	
	Anim.Duration = 400
	
	'Anim.SetInterpolator(Anim.INTERPOLATOR_OVERSHOOT  )
	Anim.Start(pnlFocus)


	Anim2.Duration = 400
	'Anim2.SetInterpolator(Anim.INTERPOLATOR_OVERSHOOT)
	Anim2.Start(pnlFocus2)

End Sub

Private Sub AnimAlpha1_AnimationEnd

End Sub

Private Sub AnimAlpha2_AnimationEnd
	'pnlFocus.Left = pnlFocus.Left + newX
	pnlFocus.RemoveView 
	pnlFocus = pnlFocus2
	'pnlFocus2.RemoveView 
End Sub

Private Sub pnlIndicator_Click
	Dim p As Panel 
	p = Sender
	CallSub2(pModule, "IndicatorClicked", p.Tag)
End Sub