﻿Type=Class
Version=2.7
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Dim pnlHolder As Panel 
	Dim pnlFooter As Panel 
	
	Dim pager As AHViewPager 
	Dim container As AHPageContainer 
	Dim pnls() As Panel 
	
	Private btnNext, btnSkip As Button 
	
	Private pi As clsPageIndicator 
	Private showPi As Boolean 
	Private AnimType As String 
End Sub

'Initializes the Wizard
'numPanels is the number of screens you want
'ShowPageIndicator enables disables the small page indicators at the bottom
'AnimType sets the Animation Type of the Page Indicators. Can be "Alpha", "Zoom", "Default"
Public Sub Initialize(numPanels As Int, ShowPageIndicator As Boolean, pAnimType As String )
	pnlHolder.Initialize("")
	Dim pnls(numPanels) As Panel 
	container.Initialize 
	For I = 0 To numPanels -1
		pnls(I).Initialize("")
		pnls(I).Tag = I
		container.AddPage(pnls(I),"")
	Next
	pager.Initialize(container,"pager")
	showPi = ShowPageIndicator
	If showPi = True Then
		pi.Initialize(Me, numPanels)
		pi.SetIndicatorSize(15dip,25dip)
		AnimType = pAnimType
	End If
End Sub

'Adds the Wizard to a parent
'You do not need to call this sub, you can just use Show
Public Sub AddToParent(parent As Panel,w As Int, h As Int)
	parent.AddView(pnlHolder, (parent.Width - w)/2,(parent.Height-h)/2,w,h)
	If showPi = False Then
		pnlHolder.AddView(pager,0,0,w,h - 50dip)
		CreateFooter(pnlFooter)
	Else
		pnlHolder.AddView(pager,0,0,w,h - 50dip)
		pi.AddToParent(pnlHolder,0,h-100dip,w,50dip)
		CreateFooter(pnlFooter)
	End If
End Sub

Private Sub CreateFooter(p As Panel)
	p.Initialize("")
	pnlHolder.AddView(p,0 ,pnlHolder.Height - 50dip, pnlHolder.Width, 50dip)
	btnNext.Initialize("btnNext")
	btnSkip.Initialize("btnSkip")
	btnNext.Text = "Next"
	btnSkip.Text = "Skip"
	btnNext.Color =  Colors.RGB(100,200,220)
	btnSkip.Color =  Colors.rgb(185,100,80)
	
	SetColorList(btnNext, Colors.RGB(100,200,220), _
						  Colors.RGB(70,180,220), _
						  Colors.RGB(100,200,220), Colors.RGB(100,200,220))
	
	SetColorList(btnSkip, Colors.rgb(185,100,80), Colors.rgb(185,80,50), _
						  Colors.rgb(185,100,80),Colors.rgb(185,100,80))
	
	btnNext.TextColor = Colors.White 
	btnSkip.TextColor = Colors.White 
	p.AddView(btnSkip, 4dip, 4dip, (p.Width - 16dip)/2, p.Height -8dip)
	p.AddView(btnNext, (p.Width + 8dip)/2, 4dip, (p.Width - 16dip)/2, p.Height -8dip)

End Sub

'Adds the StartupWizard to the parent (panel or Activity)
'Adds it at 100% size, so you can set the parentPanel's size to control the
'size of the Wizard
Public Sub Show(parent As Panel)
	AddToParent(parent, 100%x, 100%y)
End Sub

'Hides the Wizard
Public Sub Hide
	pnlHolder.RemoveView 
End Sub

'##############################
'  PRIVATE EVENTS
'##############################

Private Sub btnNext_Click
	If pager.CurrentPage = container.Count-1 Then
		Hide
	Else If pager.CurrentPage=container.Count-2 Then
		btnNext.Text = "Finish"
	Else
		btnNext.Text = "Next"
	End If
	pager.GotoPage(pager.CurrentPage+1,True)
End Sub

Private Sub btnSkip_Click
	Hide
End Sub

Private Sub pager_PageChanged (Position As Int)
	If pager.CurrentPage=container.Count-1 Then
		btnNext.Text = "Finish"
	Else
		btnNext.Text = "Next"
	End If
	If AnimType = "Scale" Then
		pi.SetFocus2(Position,"Scale")
	Else If AnimType = "Alpha" Then
		pi.SetFocus2(Position,"Alpha")
	Else
		pi.SetFocus(Position)
	End If
End Sub


Private Sub IndicatorClicked(page As Int)
	pager.GotoPage(page,True)
End Sub

'Sets up the colors of the buttons
Private Sub SetColorList(V As View, DefaultColor As Object, PressedColor As Object, _
    DisabledColor As Object, FocusedColor As Object)    
    
    ' Receives 5 states' colors. They can be a Boolean or a String in order to disable that state
    
    Dim sd As StateListDrawable
    sd.Initialize 
    If DisabledColor Is Int Then
		Dim cd As ColorDrawable 
		cd.Initialize(FocusedColor,0)
		sd.AddState(sd.State_Disabled, cd)
	End If
    If PressedColor Is Int Then
		Dim cd As ColorDrawable 
		cd.Initialize(PressedColor,0)
		sd.AddState(sd.State_Pressed, cd)
	End If
    If FocusedColor Is Int Then
		Dim cd As ColorDrawable 
		cd.Initialize(FocusedColor,0)
		sd.AddState(sd.State_Focused, cd)
	End If
    If DefaultColor Is Int Then ' must be the last one
		Dim cd As ColorDrawable 
		cd.Initialize(DefaultColor,0)
		sd.AddCatchAllState(cd)
    End If

	V.Background = sd
End Sub
